/**
 * \file mi32/mg2imagefilewriterui.h
 * \brief User Interface for MGD::IMAGEFILEWRITER
 *
 * \if NODOC
 * $Id: mg2imagefilewriterui.h_v 1.2 2006/01/05 18:48:51 mju Exp $
 *
 * $Log: mg2imagefilewriterui.h_v $
 * Revision 1.2  2006/01/05 18:48:51  mju
 * Add setDelegateOnChange.
 *
 * Revision 1.1  2005/12/08 22:39:53  mju
 * Initial revision
 *
 * \endif
**/

#if !defined(INC_MI32_MG2IMAGEFILEWRITERUI_H) && defined(USE_MGUI)
#define	INC_MI32_MG2IMAGEFILEWRITERUI_H

#ifndef INC_MGUI_MG2IMAGEFILEWRITER_H
#include <mi32/mg2imagefilewriter.h>
#endif

#ifndef INC_MGUI_COMBOBOX_H
#include <mgui/combobox.h>
#endif

#ifndef INC_MGUI_EDIT_H
#include <mgui/edit.h>
#endif

namespace MGD {

class IMAGEFILEWRITER::SETTINGS::FORM : public MGUI::FORM_COMPOSITE {
	public:

		enum FORMSTYLE {
			FORMSTYLE_Default =					0x00,
			FORMSTYLE_ExcludeNonRVC =			0x01,	//!< Exclude non-RVC formats
			};

		//! Default constructor.
		FORM (
			);

		//! Destructor.
		virtual ~FORM ();

		//! Create form.
		void Create (
			MGUI::LAYOUT_PANE_BASE& pane,
			FORMSTYLE FormStyle = FORMSTYLE_Default
			);

		//! Get current settings.
		void GetValues (
			SETTINGS& settings
			);

		void SetDelegateOnChange (
			DELEGATE_VOID_NOPARMS delegate
			) { m_DelegateOnChange = delegate; }

		//! Set current settings.
		void SetValues (
			const SETTINGS& settings
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT

		typedef FORM THISCLASS;

		SETTINGS m_Settings;
		MGUI::FORM_COMBOBOX m_CbxFormat;
		MGUI::FORM_EDIT_NUMBER m_EditCompressQuality;
		MGUI::FORM_EDIT_NUMBER m_EditCompressRatio;
		DELEGATE_VOID_NOPARMS m_DelegateOnChange;

		void AddCbxFormatItem (MGUI::ID id, const char *name, TEXTID compression);
		void OnCbxFormat ();
		void OnChangeCompressType ();
		#endif	// GENERATING_DOXYGEN_OUTPUT
	};

DEFINE_ENUM_OP_BITWISE(IMAGEFILEWRITER::SETTINGS::FORM::FORMSTYLE)

}	// End namespace MGD

#endif	// INC_MI32_MG2IMAGEFILEWRITERUI_H
