/**
 * \file serializeritemarray.h
 * \brief SERIALIZERITEMARRAY definition
 *
 * \if NODOC
 * $Id: serializeritemarray.h_v 1.3 2007/09/25 13:07:12 mju Exp $
 *
 * $Log: serializeritemarray.h_v $
 * Revision 1.3  2007/09/25 13:07:12  mju
 * Add terminate method.
 *
 * Revision 1.2  2007/09/06 21:34:34  mju
 * Add default for offsetadd parm.
 *
 * Revision 1.1  2007/08/24 21:02:12  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_SERIALIZERITEMARRAY_H
#define	INC_MI32_SERIALIZERITEMARRAY_H

#ifndef	INC_MI32_SERIALIZERITEM_H
#include <mi32/serializeritem.h>
#endif

#ifndef	INC_MI32_SIMPLEAR_H
#include <mi32/simplear.h>
#endif

class SERIALIZERITEMARRAY : public SIMPLE_ARRAY<SERIALIZERITEM> {
	public:

		SERIALIZERITEMARRAY ();

		~SERIALIZERITEMARRAY ();

		//! Append additional items to array.
		//! This is useful when building an array with class containing members with own item definitions.
		void Add (
			const SERIALIZERITEM *def2,			//!< Array to append
			int offsetadd = 0							//!< Additional "offset" to add
			);

		//! Add terminating item if necessary.
		void Terminate (
			);

	};

#endif	// INC_MI32_SERIALIZERITEMARRAY_H
